# =================================================================
# fclib configuration file.
# Check https://cmake.org/cmake/help/latest/manual/cmake-packages.7.html#creating-packages
# This file has been generated during fclib install and
# may be used by another cmake project to retrieve all the configuration variables
# of fclib.
#
#
# Usage :
# 
# find_package(fclib)

# # ... define some target ...
# target_link_libraries(my_target ${fclib_LIBRARIES})
#
# A call to find_package(fclib) 
# will set the following variables :
#
# fclib_INCLUDE_DIR = where to find fclib headers
# fclib_INCLUDE_DIRS : The final set of include directories listed in one variable for use by client code. It includes both path to fclib headers and path to external libraries headers
# fclib_LIBRARIES : the libraries to link against to use fclib
# fclib_EXTERNAL_LIBRARIES : the libraries on which fclib libs depend.
# fclib_ROOT_DIR : where to find the base directory of fclib
# fclib_FOUND : true if the find process went fine
# 
# 
# Note : var names chosen as recommended here :
# https://cmake.org/cmake/help/latest/manual/cmake-developer.7.html#manual:cmake-developer(7)
#


####### Expanded from @PACKAGE_INIT@ by configure_package_config_file() #######
####### Any changes to this file will be overwritten by the next CMake run ####
####### The input file was fclib-config.cmake.in                            ########

get_filename_component(PACKAGE_PREFIX_DIR "${CMAKE_CURRENT_LIST_DIR}/../../../" ABSOLUTE)

# Use original install prefix when loaded through a "/usr move"
# cross-prefix symbolic link such as /lib -> /usr/lib.
get_filename_component(_realCurr "${CMAKE_CURRENT_LIST_DIR}" REALPATH)
get_filename_component(_realOrig "/usr/lib/cmake/fclib-3.1.0" REALPATH)
if(_realCurr STREQUAL _realOrig)
  set(PACKAGE_PREFIX_DIR "/usr")
endif()
unset(_realOrig)
unset(_realCurr)

macro(set_and_check _var _file)
  set(${_var} "${_file}")
  if(NOT EXISTS "${_file}")
    message(FATAL_ERROR "File or directory ${_file} referenced by variable ${_var} does not exist !")
  endif()
endmacro()

macro(check_required_components _NAME)
  foreach(comp ${${_NAME}_FIND_COMPONENTS})
    if(NOT ${_NAME}_${comp}_FOUND)
      if(${_NAME}_FIND_REQUIRED_${comp})
        set(${_NAME}_FOUND FALSE)
      endif()
    endif()
  endforeach()
endmacro()

####################################################################################

include(CMakeFindDependencyMacro)

# Name of the fclib package
set(PACKAGE_NAME fclib)

# set path to fclib installation
set_and_check(fclib_ROOT_DIR "/usr")

# Path (relative to fclib install) to cmake extra tools
set(ConfigPackageLocation lib/cmake/fclib-3.1.0)

# set list of external libraries
# set(${PACKAGE_NAME}_EXTERNAL_LIBRARIES "")

# include fclib project targets
include("${CMAKE_CURRENT_LIST_DIR}/fclibTargets.cmake")

set_and_check(FCLIB_INCLUDE_DIR "/usr/include")

set(FCLIB_HEADER_ONLY OFF)
set(FCLIB_WITH_MERIT_FUNCTIONS ON)

find_dependency(HDF5 COMPONENTS C HL REQUIRED)

if(FCLIB_WITH_MERIT_FUNCTIONS)
  # add path to cs.h from libsuitesparse-dev
  target_include_directories(FCLIB::fclib INTERFACE /usr/include/suitesparse)
endif()

# set list of include dirs for external libraries
# set(${PACKAGE_NAME}_INCLUDE_DIRECTORIES )
#list(APPEND ${PACKAGE_NAME}_INCLUDE_DIRECTORIES /usr/include/fclib)
set(CMAKE_CXX_STANDARD )

# --- Final check to set (or not) fclib_FOUND, fclib_numerics_FOUND and so on
check_required_components(fclib)


